c     program     :     DEF_CMORPH1.0CRT_CLIM_GLB_step_03_def_BLD_clim_hly_har_final.lnx.f
c     objective   :     to define the daily climatology as the summation of the first 6 harmonics   
c 
      parameter  ( nx = 1440, ny = 480, nday = 365 )
      character   cfile10*56, 
     #            cfile50*55,cfile60*55         
c
      dimension   rain0 (nx,ny,10), rain1 (nx,ny),  
     #            rain59 (nx,ny), rain61 (nx,ny) 
c
c     1.  to open files
c
      write  (6,*)  'started  defining station hourly climatology !!' 
c
      cfile10 ( 1: 7) = '../rslt'
      cfile10 ( 8:37) = '/CMORPH1.0CRT_CLIM_DLY_0.25deg'
      cfile10 (38:56) = '_DAY-BY-DAY_HAR.lnx'
      cfile50 ( 1: 7) = '../rslt'
      cfile50 ( 8:37) = '/CMORPH1.0CRT_CLIM_DLY_0.25deg'
      cfile50 (38:55) = '_1998-2017_365.lnx'
      cfile60 ( 1: 7) = '../rslt'
      cfile60 ( 8:37) = '/CMORPH1.0CRT_CLIM_DLY_0.25deg'
      cfile60 (38:55) = '_1998-2017_366.lnx'
c
      open  (unit=10,
     #       file=cfile10,
     #       access='direct', recl=nx*ny*10*4)
      open  (unit=50,
     #       file=cfile50,
     #       access='direct', recl=nx*ny*4)
      open  (unit=60,
     #       file=cfile60,
     #       access='direct', recl=nx*ny*4)
      write  (6,*)  '     finished openning files !!' 
c
c     2.  to define 365-day climatology   
c
      do 2999 kday = 1, nday  
c
c       2.1  to read in truncated field   
        kinp = kday  
        read  (10,rec=kinp)   rain0   
c
c       2.2  to define the climatology as the summation of first 6 harmonics 
        do 2206 jj = 1, ny 
        do 2206 ii = 1, nx    
c 
          if  (rain0(ii,jj,2).lt.0.0)  then 
            rain1 (ii,jj) = -999.0 
          else  if  (rain0(ii,jj,2).eq.0)  then 
            rain1 (ii,jj) = 0.0 
          else 
            rain1 (ii,jj) = 0.0 
            do 2203 kff = 2, 8        
              rain1 (ii,jj) = rain1 (ii,jj) + rain0 (ii,jj,kff) 
 2203       continue 
            if  (rain1(ii,jj).lt.0.01)  then 
              rain1 (ii,jj) = 0.01  
            end  if  
          end  if  
 2206   continue 
c
c       2.3  to output 
        kout = kday 
        write  (50,rec=kout)  rain1  
c 
        write  (6,*)  '          finished for day :', kday  
c
 2999 continue 
      write  (6,*)  '     finished defining 365-day daily clim !!'
c
c     3.  to define 366-day clim 
c 
      do 3999 kday = 1, 366 
c 
        if (kday.le.59)  then 
c
          kinp = kday 
          kout = kday 
          read  (50,rec=kinp)  rain1  
          write (60,rec=kout)  rain1   
c 
        else  if  (kday.ge.61)  then 
c 
          kinp = kday - 1 
          kout = kday 
          read  (50,rec=kinp)  rain1  
          write (60,rec=kout)  rain1  
c 
        else 
          read  (50,rec=59)  rain59 
          read  (50,rec=60)  rain61 
          do 3001 jj = 1, ny  
          do 3001 ii = 1, nx  
            if  (rain59(ii,jj).ge.0.0.and. 
     #           rain61(ii,jj).ge.0.0)  then 
              rain1 (ii,jj) = (rain59(ii,jj)+rain61(ii,jj))*0.5 
            else  if  (rain59(ii,jj).ge.0.0)  then 
              rain1 (ii,jj) = rain59 (ii,jj) 
            else  if  (rain61(ii,jj).ge.0.0)  then 
              rain1 (ii,jj) = rain61 (ii,jj) 
            else 
              rain1 (ii,jj) = -999.0 
            end  if  
 3001     continue 
          kout = kday 
          write  (60,rec=kout)  rain1  
c 
        end  if    
c 
 3999 continue 
      write  (6,*)  '     finished defining 366-day clim !!' 
c
      write  (6,*)  'finished defining station hourly climatology !!' 
c
c 
      stop 
      end  
